using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using SubscriptionWSClient.localhost;

namespace SubscriptionWSClient
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.HyperLink HyperLink1;
		protected System.Web.UI.WebControls.DataList DataList1;
	
		public WebForm1()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(Page.IsPostBack==false)
			{
				CSubscription nl=new CSubscription();
				if(nl.IsValid(Session["email"].ToString(),Session["pwd"].ToString())==false)
					Label3.Text="You are about to subscribe to our newsletters";
				else
					Label3.Text="You are about to modify your subscriptions to our newsletters";
				HyperLink1.Text=Session["email"].ToString();
				HyperLink1.NavigateUrl="mailto:" + Session["email"].ToString();
				DataList1.DataSource=nl.GetNewsletterDetails();
				DataList1.DataBind();
			}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		public void OnSubscribe(object sender, EventArgs e)
		{
			CSubscription nl=new CSubscription();
			ArrayList sub=new ArrayList();
			ArrayList unsub=new ArrayList();

			for(int i=0;i<DataList1.Items.Count;i++)
			{
				if(DataList1.Items[i].ItemType==ListItemType.Item ||DataList1.Items[i].ItemType==ListItemType.AlternatingItem)
				{
					CheckBox c=(CheckBox)DataList1.Items[i].FindControl("CheckBox1");
					Label l=(Label)DataList1.Items[i].FindControl("Label2");
					if(c.Checked)
						sub.Add(l.Text);
					else
						unsub.Add(l.Text);
				}
			}
			nl.Subscribe(Session["email"].ToString(),Session["pwd"].ToString(),(string[])sub.ToArray(typeof(string)));
			nl.Unsubscribe(Session["email"].ToString(),Session["pwd"].ToString(),(string[])unsub.ToArray(typeof(string)));

		}


		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.DataList1.ItemDataBound += new System.Web.UI.WebControls.DataListItemEventHandler(this.DataList1_ItemDataBound);
			this.DataList1.SelectedIndexChanged += new System.EventHandler(this.DataList1_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DataList1_SelectedIndexChanged(object sender, System.EventArgs e)
		{

		}

		private void DataList1_ItemDataBound(object sender, System.Web.UI.WebControls.DataListItemEventArgs e)
		{
			CSubscription nl=new CSubscription();
			DataSet ds=null;
			ds=nl.GetSubscribtions(Session["email"].ToString(),Session["pwd"].ToString());
			if(ds.Tables.Count>0)
			{
				if(e.Item.ItemType==ListItemType.Item || e.Item.ItemType==ListItemType.AlternatingItem)
				{
					Label l=(Label)e.Item.FindControl("Label2");
					CheckBox c=(CheckBox)e.Item.FindControl("CheckBox1");
					foreach(DataRow r in ds.Tables[0].Rows)
					{
						if(r["id"].ToString()==l.Text)
							c.Checked=true;
					}
				}
			}
			
		}
	}
}
